
%define name aplus-fsf
%define ver 4.20
%define rel 2

%define _x11pref %{_datadir}/X11
%define _x11bindir %{_bindir}
%define _lispdir %{_datadir}/xemacs/site-packages/lisp
%define _lispstart %{_lispdir}/site-start.d
%define _x11lib %{_libdir}
%define _fonts %{_datadir}/fonts
%define _x11fonts %{_fonts}/apl/pcf
%define _ttffonts %{_fonts}/apl/TrueType
%define _x11appdef %{_x11pref}/app-defaults

Name: %name
Version: 4.20.2
Release: 13%{?dist}
License: GPL

Summary: Advanced APL interpreter with s interface

URL: http://www.aplusdev.org
Group: Development/Languages

Source: http://www.aplusdev.org/Download/%name-%ver-%rel.tar.gz
Source1: aplus-fsf-4.20-elstart
Patch1: aplus-fsf-4.20-makefile.patch
Patch2: aplus-fsf-4.20-gcc41.patch
Patch3: aplus-fsf-4.20-el.patch
Patch4: aplus-fsf-4.20-atree.patch

BuildRequires: xorg-x11-proto-devel
BuildRequires: automake16 autoconf

Requires: xterm

Requires: fonts-apl
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
A+ is a Morgan Stanley array programming environment that includes 
a rich set of functions and operators, handling of files as ordinary 
arrays, a GUI with many widgets and automatic synchronization of 
widgets and variables (using MStk in A+ Version 4), generalized 
spreadsheet-like interactions, asynchronous execution of functions 
that have been associated with variables and events, interprocess 
communication, calls to user C subroutines, and many other features. 
Execution is by a very efficient interpreter. 

%package -n fonts-x11-apl
Summary: X11 Fonts for the Advanced APL Interpreter
Group: User Interface/X
Provides: fonts-apl
Requires(post): %{_x11bindir}/mkfontdir
Requires(post): fontconfig, chkfontpath
Requires(postun): %{_x11bindir}/mkfontdir, fontconfig
%description -n fonts-x11-apl
The A+ programming language development environment requires these 
APL fonts to properly display A+ code in XTerm or XEmacs.

this packages contans the fonts in the PCF format.

They are not require to run a A+ program.

%package -n fonts-truetype-apl
Summary: TreuType fonts for the Advanced APL Interpreter
Group: User Interface/X
Provides: fonts-apl
Requires(post): %{_x11bindir}/mkfontdir, ttmkfdir, fontconfig, chkfontpath
Requires(postun): %{_x11bindir}/mkfontdir, ttmkfdir, fontconfig

%description -n fonts-truetype-apl
The A+ programming language development environment requires these 
APL fonts to properly display A+ code in XTerm or XEmacs.

These package contains the fonts in the TrueType format.

They are not requires to run a A+ program.

%package -n xemacs-%{name}
Summary: XEmacs lisp for A+ development
Group: Applications/Editors
Requires: xemacs, aplus-fsf
%description -n xemacs-%{name}
This package contains the XEmacs lisp required for the development
of A+ programs. It does the key bindings, set of fonts property 
and bind some function keys. The complete A+ development is provided
by the aplus-fsf package.

%package devel 
Summary: Header files from the A+ environment
Group: Development/Libraries
Requires: aplus-fsf = %{version}
%description devel
This package contains the header file from the A+ libraries.

%prep
%setup -q -n %{name}-%{ver}
%patch1 -p1 -b .org
%patch2 -p1 
%patch3 -p1
%patch4 -p1

%build
# export CXXFLAGS=-O3 CFLAGS=-O3
export CFLAGS=$RPM_OPT_FLAGS 
export CXXLFAGS=$RPM_OPT_FLAGS
automake-1.6
autoconf
%configure --prefix=/usr
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.la
rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.a

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/a+
cp $RPM_BUILD_ROOT/%{_libdir}/*.+ $RPM_BUILD_ROOT/%{_libdir}/a+/
rm -rf $RPM_BUILD_ROOT/%{_libdir}/*.+ 

# Move libs in an other dir to solve conflicts

mkdir -p $RPM_BUILD_ROOT/%{_libdir}/aplus-fsf/%{version}

cp $RPM_BUILD_ROOT/%{_libdir}/lib*.so $RPM_BUILD_ROOT/%{_libdir}/aplus-fsf/%{version}
rm -f $RPM_BUILD_ROOT/%{_libdir}/lib*.so*

mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/ld.so.conf.d
echo '%{_libdir}/aplus-fsf/%{version}' >$RPM_BUILD_ROOT/%{_sysconfdir}/ld.so.conf.d/aplus-fsf-%{_arch}.conf

mkdir -p $RPM_BUILD_ROOT/%{_lispstart}/aplus-fsf
cp %{SOURCE1} $RPM_BUILD_ROOT/%{_lispstart}/aplus-fsf-init.el

pushd $RPM_BUILD_ROOT/%{_x11appdef}
mv XTerm XTerm-apl
popd

cp -R src/scripts samples

mv samples/Makefile samples/Makefile-%{_arch}

pushd $RPM_BUILD_ROOT/%{_x11fonts}/

cp Kapl.alias fonts.alias

rm -f {encodings,fonts}.dir
touch {encodings,fonts}.dir
chmod 0644 {encodings,fonts}.dir

for fcver in $(seq 1 9); do
  touch fonts.cache-$fcver
  chmod 0644 fonts.cache-$fcver
done

popd

pushd $RPM_BUILD_ROOT/%{_ttffonts}/

touch fonts.{alias,scale}
chmod 0644 fonts.{alias,scale}

rm -f {encodings,fonts}.dir
touch {encodings,fonts}.dir
chmod 0644 {encodings,fonts}.dir

for fcver in $(seq 1 9); do
  touch fonts.cache-$fcver
  chmod 0644 fonts.cache-$fcver
done

popd

%clean
rm -rf $RPM_BUILD_ROOT

%post -n fonts-x11-apl

  FONTDIR=%{_x11fonts}
  mkfontdir $FONTDIR
  fc-cache $FONTDIR
  chkfontpath -qa $FONTDIR

%post -n fonts-truetype-apl

  FONTDIR=%{_ttffonts} 
  ttmkfdir -d $FONTDIR -o $FONTDIR/fonts.scale
  mkfontdir $FONTDIR
  chkfontpath -qa $FONTDIR
  fc-cache $FONTDIR

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%postun -n fonts-x11-apl

  FONTDIR=%{_x11fonts}
  if [ "$1" = "0" ]; then
    mkfontdir $FONTDIR
    fc-cache $FONTDIR:unscaled
    chkfontpath -qr $FONTDIR
  fi

%postun -n fonts-truetype-apl

  FONTDIR=%{_ttffonts}
  if [ "$1" = "0" ]; then
    ttmkfdir -d $FONTDIR -o $FONTDIR/fonts.scale
    mkfontdir $FONTDIR
    fc-cache $FONTDIR
    chkfontpath -qr $FONTDIR
  fi

%files
%defattr(-,root,root,-)
%{_bindir}/a+
%{_libdir}/aplus-fsf/
%{_libdir}/a+
%dir %{_x11appdef}
%{_x11appdef}/XTerm-apl
%{_fonts}/
%{_sysconfdir}/ld.so.conf.d/aplus-fsf-%{_arch}.conf

%doc samples
%doc ANNOUNCE AUTHORS ChangeLog LICENSE README

%files devel
%defattr(-,root,root,-)
%{_includedir}/a+

%doc COPYING

%files -n xemacs-%{name}
%defattr(-,root,root,-)
%{_lispdir}/aplus-fsf
%{_lispstart}/aplus-fsf-init.el

%files -n fonts-x11-apl
%defattr(-,root,root,-)
%{_x11fonts}/K*
%ghost %verify(not md5 size mtime) %{_x11fonts}/encodings.dir
%ghost %verify(not md5 size mtime) %{_x11fonts}/fonts.dir
%ghost %verify(not md5 size mtime) %{_x11fonts}/fonts.alias
%ghost %verify(not md5 size mtime) %{_x11fonts}/fonts.cache-*

%files -n fonts-truetype-apl
%defattr(-,root,root,-)
%{_ttffonts}/K*
%ghost %verify(not md5 size mtime) %{_ttffonts}/encodings.dir
%ghost %verify(not md5 size mtime) %{_ttffonts}/fonts.dir
%ghost %verify(not md5 size mtime) %{_ttffonts}/fonts.alias
%ghost %verify(not md5 size mtime) %{_ttffonts}/fonts.scale
%ghost %verify(not md5 size mtime) %{_ttffonts}/fonts.cache-*

%Changelog
* Tue Feb 13 2007 Jochen Schmitt <s4504kr@zeus.herr-schmitt.de> 4.20.2-13
- Solve multilib issue (#228353)

* Mon Dec 11 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-12
- Change version schema for dynamic libs

* Tue Dec  5 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-11
- Fix name conflict in an other way

* Mon Sep  4 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-10
- Fix apl font problem

* Wed Aug  9 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-9
- Rebuilt to sync Release-Tag with FC-4

* Tue Aug  8 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-6
- Fix fonts problems
- Fix atree problems

* Sun Jul 23 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-5
- Add xterm as BR for app-defaults
- Solve the weak-ref problem

* Tue Jul 11 2006 Jochen Schmitt <Jochen herr-schmitt.de> 4.20.2-4
- Reorg of rel-macro
- Own of app-defaults
- Change the name of the emacs subpackage according to the naming guidelines

* Mon Jul 10 2006 Jochen Schmitt <Jochen herr-schmitt.de> 4.20.2-3
- Fix BR for TTF subpackage.
- Fix LICENSE file.

* Wed May 31 2006 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2-2
- Adopt to Modular X

* Wed Nov 23 2005 Jochen Schmitt <Jochen herr-schmitt de> 4.20.2:1
- Initial RPM
